<template>
    <div
      class="room"
      :style="darkMode"
      @click="$emit('goToPatient',patient.id)">
      <p class="absolute-top-left text-subtitle2 kamerNummer" v-show="settings.nummer">{{kamer.id}}</p>
       <q-banner dense inline-actions class="bannerColor text-white" :style="kleur" :class="{alarmAnimatie: alarmActief}">
    </q-banner>
      <div  v-if="patient != null"  class="absolute-center center">
      <q-chip  outline  v-show="settings.patiënt">
        <q-avatar>
          <img v-if="patient.id !== null" :src="'http://localhost:3000/images/'+ patient.foto">
          <img v-else src="">
        </q-avatar>
        {{patient.naam}}
      </q-chip>
      <div v-show="settings.monitoringData">
        <q-chip outline square  icon="fas fa-heartbeat">
      {{patient.hartslag}}
    </q-chip>
        <q-chip outline square  icon="fas fa-tint">
      {{patient.bloeddruk}}
    </q-chip>
      </div>
      <div  v-show="settings.eerstvolgendeActie">
         <q-chip outline square    icon="fas fa-clock">
      {{eerstVolgendeActie.tijdstip}}
    </q-chip>
        <q-chip outline square  icon="fas fa-file-medical-alt">
      {{eerstVolgendeActie.type}}
    </q-chip>
      </div>
      </div>
      <div class="absolute-bottom-left" v-show="settings.faciliteiten"> <q-icon
          class="icon"
          v-for="naamfacil in kamer.faciliteiten"
          :key="naamfacil"
          :name="naamfacil"
        /></div >
<div v-if="patient == null" class="absolute-center text-h6">kamer is vrij</div>
</div>
</template>

<style scoped>
.room {
position: absolute;
box-shadow: 0px 21px 16px -6px rgba(0,0,0,0.75);
   cursor: pointer;
}
.icon {
  font-size: 15px;
  margin-right: 7px;
  margin-left: 3px;
}
.bannerColor {
  min-height: 10px
}

.center {
text-align: center
}

.kamerNummer {
  color: black;
  margin-left: 2px
}
</style>

<script>
import Utils from '../utils'

export default {
  name: 'RoomPlan',
  data () {
    return {
      settings: this.$store.getters['settings/settings'],
      color: this.backgroundColor
    }
  },
  props: {
    kamer: Object,
    patient: [Object, Function],
    eerstVolgendeActie: [Object, Function],
    backgroundColor: String,
    alarmActief: Boolean
  },
  methods: {
    // als er een drempelwaarde wordt overgeschreden dan zal dit toegevoegd worden in de array [arrayAlarm] bij de pagina 'Afdeling'

    alarmColor () {
      if (this.color === 'background-color:white') {
        this.color = 'background-color:' + this.settings.kleuren.alarm
      } else {
        this.color = 'background-color:white'
      }
    }
  },
  watch: {
    // als er een drempelwaarde wordt overgeschreden dan zal dit toegevoegd worden in de array [arrayAlarm] bij de pagina 'Afdeling'
    patient () {
      if (this.patient.hartslag < this.settings.minHart || this.patient.hartslag > this.settings.maxHart) {
        this.$emit('pushToArray', true)
      } else if (this.patient.bloeddruk < this.settings.minBloed || this.patient.bloeddruk > this.settings.maxBloed) {
        this.$emit('pushToArray', true)
      } else {
        this.$emit('pushToArray', false)
      }
    },
    // zelfgemaakte manier om een animatie te maken voor het alarm met een kleur naar keuze die je bij de instellingen kan aanpassen
    alarmActief () {
      if (this.alarmActief === true) {
        setInterval(this.alarmColor, 700)
      } else {
        clearInterval(this.alarmColor, 700)
      }
    },
    // indien er een eerst volgende actie is zal er een gradient verschijnen aan de bovenkant van de lijst (zie streep) en bij het balkje wanneer je de map bekijkt
    eerstVolgendeActie () {
      if (this.eerstVolgendeActie !== undefined) {
        this.color = Utils.calculateColor(this.eerstVolgendeActie, this.settings, this.kamer)
      }
    }
  },
  computed: {
    // indien darkmode is ingeschakeld zullen de kleuren van de borders van zwart naar wit veranderen
    darkMode: function () {
      if (this.$q.dark.isActive) {
        return { border: '2px solid white', left: this.kamer.x + 'px', top: this.kamer.y + 'px', width: this.kamer.width + 'px', height: this.kamer.height + 'px' }
      } else {
        return { border: '2px solid black', left: this.kamer.x + 'px', top: this.kamer.y + 'px', width: this.kamer.width + 'px', height: this.kamer.height + 'px' }
      }
    },
    // de positie van de div wordt gegeven en geplaatst in de style attribute van de div
    getPosition: function () {
      return {
        left: this.kamer.x + 'px', top: this.kamer.y + 'px', width: this.kamer.width + 'px', height: this.kamer.height + 'px'
      }
    },
    kleur () {
      return this.color
    }
  }
}

</script>
